/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.data;

import java.awt.*;

/**
 * Prompt - interface for a user interface prompt.  Left hand side is usually
 * a label with colon.  Right is usually a text field for value.  But nothing
 * is mandatory except that there be a left component and a right component,
 * so a PromptBlock can lay it out.
 *
 * @see		COM.dtai.data.PromptBlock
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: Prompt.java,v 1.1 1996/07/29 21:12:38 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/data/Prompt.java,v $
 */

public interface Prompt
{
	/**
	 * Returns the left hand component (usually the name label of the Prompt).
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
	public Component getLeftComponent();

	/**
	 * Returns the right hand component (usually the editable value component, like
	 * a TextField).
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
	public Component getRightComponent();

	/**
	 * Returns true if there have been changes made to the Prompt but they haven't
	 * been saved to the Data object yet.
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
	public boolean isModified();
}
