/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.data;

import java.awt.*;
import java.util.*;

/**
 * PromptBlock - layout for a bunch of Prompts
 *
 * @see		COM.dtai.data.Prompt
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: PromptBlock.java,v 1.1 1996/07/29 21:12:39 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/data/PromptBlock.java,v $
 */

public class PromptBlock extends Panel {

    private Vector prompts = new Vector();
    private GridBagLayout gridbag = new GridBagLayout ();
    private GridBagConstraints constraints;

	/**
	 * Constructs a PromptBlock container
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public PromptBlock () {

        setLayout ( gridbag );

        constraints = new GridBagConstraints ();
        constraints.gridx = 0;
        constraints.gridy = 0;
        constraints.gridwidth = 1;
        constraints.gridheight = 1;
        constraints.fill = GridBagConstraints.NONE;
        constraints.anchor = GridBagConstraints.EAST;
        constraints.weightx = 0.0;
        constraints.weighty = 0.0;
        constraints.insets = new Insets( 2, 0, 2, 0 );
    }

	/**
	 * Adds a Prompt to the block.
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void addPrompt( Prompt prompt ) {

        prompts.addElement( prompt );

        constraints.gridx = 0;
        constraints.anchor = GridBagConstraints.EAST;
        gridbag.setConstraints ( prompt.getLeftComponent(), constraints );
        add ( prompt.getLeftComponent() );

        constraints.gridx = 1;
        constraints.anchor = GridBagConstraints.WEST;
        gridbag.setConstraints ( prompt.getRightComponent(), constraints );
        add ( prompt.getRightComponent() );

        constraints.gridy++;
    }

	/**
	 * Returns true if any of the Prompts have been modified
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public boolean isModified() {
        for ( Enumeration e = prompts.elements(); e.hasMoreElements(); ) {
            if ( ((Prompt)e.nextElement()).isModified() ) {
                return true;
            }
        }
        return false;
    }
}
