/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.data;

/**
 * ValueObserver - allows any class to implement this interface and then
 * get registered to be "called back" when a particular Data value changes.
 *
 * @see		COM.dtai.data.Data
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: ValueObserver.java,v 1.1 1996/07/29 21:12:39 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/data/ValueObserver.java,v $
 */

public interface ValueObserver {
	/**
	 * Notifies the ValueObserver that the Data value has changed
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    void valueChanged( Data data, Object arg );

	/**
	 * Asks the ValueObserver to try to save any current changes to the Data
	 * object, or return false if there was some problem.
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return false if there was a problem with the value and it cannot be accepted
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    boolean acceptChange( Data data, Object arg );
}
