/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.gui;

import java.awt.*;
import java.util.*;

/**
 * SimpleDialog - superclass for error, warning, info, etc. dialogs
 *
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: SimpleDialog.java,v 1.1 1996/07/29 21:12:47 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/gui/SimpleDialog.java,v $
 */

public class SimpleDialog extends StdDialog {

    private Vector  labels = new Vector();
    private Label   text_label;
    private int justification = Label.LEFT;
    private int max_line_length = 40;

    protected SimpleDialog( Frame  frame, String dialog_header ) {
        super( frame, dialog_header, true );
    }

    protected SimpleDialog( Frame  frame, String dialog_header,
							String default_button ) {
        this( frame, dialog_header );
        addButton ( new Button ( default_button ) );
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void setLeftJustified() {
        justification = Label.LEFT;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void setRightJustified() {
        justification = Label.RIGHT;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void setCenterText() {
        justification = Label.CENTER;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void setMaxLineLength( int len ) {
        max_line_length = len;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public void setMessage( String message ) {

        int     start;
        int     i;
        int     n;
        String  text = "";
        boolean break_line = false;
        Panel mainpanel = getMainPanel();

        for ( i = 0; i < labels.size(); i++ ) {
            mainpanel.remove( (Label)labels.elementAt(i) );
        }
        labels.removeAllElements();

        start = 0;
        n = 0;
        for ( i = 0; i < message.length(); i++ ) {
            if ( message.charAt(i) == '\n' ) {
                text = message.substring(start,i);
                start = i+1;
                break_line = true;
            }
            else if ( n > max_line_length
                      && ( message.charAt(i) == ' '
                           || message.charAt(i) == '\t' ) ) {
                text = message.substring( start, i );
                while ( ( i < message.length() )
                        && ( message.charAt(i) == ' '
                             || message.charAt(i) == '\t' ) ) {
                    i++;
                }
                start = i;
                break_line = true;
            }
            else {
                n++;
            }

            if ( break_line == true ) {
                text_label = new Label( text, justification );
                labels.addElement( text_label );
                break_line = false;
                n = 0;
            }
        }
        if ( start < i ) {
            text = message.substring(start,i);
            text_label = new Label( text, justification );
            labels.addElement( text_label );
        }

        mainpanel.setLayout( new GridLayout( labels.size(), 1, 0, 0 ) );
        for ( i = 0; i < labels.size(); i++ ) {
            mainpanel.add ( (Label)labels.elementAt(i) );
        }
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public boolean action( Event evt, Object arg ) {
        if ( evt.target instanceof Button ) {
            if ( ((Button)evt.target).getLabel().equals( "OK" ) ) {
                hide ();
                return( true );
            }
        }
        else {
            return( false );
        }
        return( true );
    }
}

