/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.net;

import java.net.*;
import java.io.*;

/**
 * NetPortToServer - in client/server, this is a class in the client that
 * provides a simple API for a socket interface to some server
 *
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: NetPortToServer.java,v 1.3 1996/07/22 23:52:30 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/net/NetPortToServer.java,v $
 */

public class NetPortToServer extends NetPort {

	/**
	 * constructs the object from the server machine's hostname and TCP/IP
	 * port number to connect to.
	 * 
	 * @param host the hostname
	 * @param port the port number
	 * @exception IOException if an IO error occurred
	 */
    public NetPortToServer ( String host, int port ) throws IOException {
        super ( new Socket ( host, port ) );
    }

	/**
	 * constructs the object from the server machine's Internet address and
	 * TCP/IP port number to connect to.
	 * 
	 * @param address the Internet address
	 * @param port the port number
	 * @exception IOException if an IO error occurred
	 */
    public NetPortToServer ( InetAddress address, int port )
		throws IOException {
        super ( new Socket ( address, port ) );
    }
}
