/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package COM.dtai.util;

import java.io.*;

/**
 * Syslog - The API to a generic System log that can be output to a file or
 * other print stream.
 *
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: Syslog.java,v 1.1 1996/08/13 06:29:27 kadel Exp $
 *
 * $Source: /cvs/java/classes/COM/dtai/util/Syslog.java,v $
 */

public final class Syslog
{
    private static PrintStream ps = System.err;
    private static boolean enabled = true;
    private static String last_error = null;
    private static String last_warning = null;
    private static Exception last_exception = null;

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public static final void enableLogging(boolean flag)
    {
		enabled = flag;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public synchronized static final void setStream(OutputStream os)
    {
		if (os instanceof PrintStream) ps = (PrintStream)os;
		else ps = new PrintStream(os);
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public synchronized static final void error(String msg)
    {
		if (enabled && msg != null) ps.println("ERROR: " + msg);
		last_error = msg;
    }

    public synchronized static final void error(Exception err)
    {
		if (enabled && err != null) {
			ps.println("EXCEPTION: " + err);
			err.printStackTrace(ps);
		}
		last_exception = err;
    }

	/**
	 * DESCRIPTION
	 * 
	 * @param PARAMNAME DESCRIPTION
	 * @return DESCRIPTION
	 * @exception CLASSNAME DESCRIPTION
	 * @see CLASSNAME#METHOD
	 */
    public synchronized static final void warning(String msg)
    {
		if (enabled && msg != null) ps.println(msg);
		last_warning = msg;
    }

    public String getLastError()
    {
		return last_error;
    }

    public String getLastWarning()
    {
		return last_warning;
    }

    public Exception getLastException()
    {
		return last_exception;
    }
}
