/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

import java.awt.*;

/**
 * NodeComponent - a displayed component of an OrgChart node
 *
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: NodeComponent.java,v 1.2 1996/07/22 23:52:09 kadel Exp $
 *
 * $Source: /cvs/java/OrgChart/NodeComponent.java,v $
 */

public abstract class NodeComponent {

    protected abstract Dimension size( OrgNode node );

    protected abstract void draw( Graphics g, OrgNode node,
                                  int center_x, int top_y,
                                  boolean hilited, boolean disabled,
                                  boolean armed );

    protected abstract void draw( Graphics g, OrgNode node,
                                  int center_x, int top_y );
}
