/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

package orgdata;

import COM.dtai.serial.*;

/**
 * OrgChartDbCommands - holds the command IDs for communication between the
 * OrgChartDbServer and a client (requests and status code responses).
 *
 * @version	1.0b1
 * @author	DTAI, Incorporated
 *
 * $Id: OrgChartDbCommands.java,v 1.12 1996/08/06 05:47:01 marsh Exp $
 *
 * $Source: /cvs/java/classes/orgdata/OrgChartDbCommands.java,v $
 */

public abstract class OrgChartDbCommands extends DbCommands {

    /**
     * a query to the server to return the orgnode with the given id
     */
    public static final int GetOrgNodeById = 201;

    /**
     * a query to the server to return all orgnodes with the given parent id
     */
    public static final int GetOrgNodeByParent = 202;

    /**
     * a query to the server to return all orgnodes with the given section title
     */
    public static final int GetOrgNodeBySection = 203;

    /**
     * a query to the server to return the employee with the given id
     */
    public static final int GetEmployeeById = 204;

    /**
     * tells server to get a multi-level branch
     */
    public static final int GetOrgChartBranchByParent = 205;

    /**
     * tells server to get a multi-level branch
     */
    public static final int GetOrgChartBranchBySection = 206;

    /**
     * asks server to return the highest orgnode id value
     */
    public static final int GetMaxOrgNodeId = 207;

    /**
     * asks server to return the highest employee id value
     */
    public static final int GetMaxEmployeeId = 208;

    /**
     * removes an orgnode
     */
    public static final int DeleteOrgNode = 209;

    /**
     * removes an employee
     */
    public static final int DeleteEmployee = 210;

    /**
     * Adds the given orgnode
     */
    public static final int SaveOrgNode = 211;

    /**
     * Adds the given employee
     */
    public static final int SaveEmployee = 212;
}
