/**
 * Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
 *
 *                        All rights reserved
 *
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of DTAI, Incorporated not be used in
 * advertising or publicity pertaining to this material without the
 * specific, prior written permission of an authorized representative of
 * DTAI, Incorporated.
 *
 * DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
 * EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
 * INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
 * TO THE SOFTWARE.
 */

////////////////////////////////
// spawn.c - this is a hacked out program
// to spawn a new background process with
// the given executable name and arguments.
// This is good for Windows 95 and NT only.
////////////////////////////////

#include <stdio.h>
#include <windows.h>
#include <io.h>

int main( int argc, char* argv[] ) {

	char command_line[256];
	char infilename[64];
	char outfilename[64];
	char errfilename[64];
	int idx;
	int got_program = 0;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	if ( argc < 2 ) {
		fprintf( stderr,
				 "usage: %s [-i dummy_stdin_filename] [-o stdout_filename]\n"
				 "[-e stderr_filename] program args...\n",
				 argv[0] );
		return( 1 );
	}

	strcpy( infilename, "dummyinput" );
	strcpy( outfilename, argv[1] );
	strcat( outfilename, ".out" );
	strcpy( errfilename, argv[1] );
	strcat( errfilename, ".err" );

	command_line[0] = '\0';
	for ( idx = 1; idx < argc; idx++ ) {
		if ( ! got_program ) {
			if ( argv[idx][0] != '-' ) {
				got_program = 1;
			}
			else {
				if ( argv[idx][1] == 'i' ) {
					strcpy( infilename, argv[++idx] );
				}
				else if ( argv[idx][1] == 'o' ) {
					strcpy( outfilename, argv[++idx] );
				}
				else if ( argv[idx][1] == 'e' ) {
					strcpy( errfilename, argv[++idx] );
				}
			}
		}
		if ( got_program ) {
			strcat( command_line, argv[idx] );
			strcat( command_line, " " );
		}
	}

	fclose( fopen( infilename, "w" ) );

	ZeroMemory( &si, sizeof( si ) );
	si.cb = sizeof( si );

	si.hStdInput = CreateFile( infilename, GENERIC_READ, FILE_SHARE_READ, NULL,
							   OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0L );

	si.hStdOutput = CreateFile( outfilename, GENERIC_WRITE, FILE_SHARE_READ, NULL,
							    CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0L );

	si.hStdError = CreateFile( errfilename, GENERIC_WRITE, FILE_SHARE_READ, NULL,
							   CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0L );

	si.dwFlags = STARTF_USESTDHANDLES | STARTF_FORCEOFFFEEDBACK;

	CreateProcess( 0L, command_line, NULL, NULL, FALSE,
		           DETACHED_PROCESS | CREATE_NEW_PROCESS_GROUP |
				   CREATE_DEFAULT_ERROR_MODE,
				   NULL, NULL, &si, &pi );
	return( 0 );
}