#!/usr/ns-home/install/perl
# make sure the line above is correct!

######################################
# Configuration (This script is for Unix users only!
# Windows NT users please refer to start_server.bat.)
######################################

#####
# FIRST!  Be sure the first line of this file
# refers to the proper place for the perl executable.

#####
# SECOND, check and/or reset the ostype and the following
# directories:

$org_chart_dir = "/usr/ns-home/docs/OrgChart_DTAI";

$javadir = "/usr/local/java";

$javaclasses = "$javadir/lib/classes.zip";

#####
# THIRD, Set any other required environment variables.
# Some JDKs require more than others. For example:
# $ENV{'SYSNAME'} = "hp700_ux100";

#    $ENV{'SYSNAME'} = "hp700_ux100";		# UNIX (some)

#####
# END OF USER-MODIFIABLE PARAMETERS

# DO NOT MAKE CHANGES BELOW THIS LINE
#################################################################

# Copyright(c) 1996 DTAI, Incorporated (http://www.dtai.com)
#
#                        All rights reserved
#
# Permission to use, copy, modify and distribute this material for
# any purpose and without fee is hereby granted, provided that the
# above copyright notice and this permission notice appear in all
# copies, and that the name of DTAI, Incorporated not be used in
# advertising or publicity pertaining to this material without the
# specific, prior written permission of an authorized representative of
# DTAI, Incorporated.
#
# DTAI, INCORPORATED MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES,
# EXPRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
# NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST
# INFRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
# SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL DTAI, INCORPORATED OR
# ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
# LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELATING
# TO THE SOFTWARE.
###########################################################################

$output_log = "$org_chart_dir/log/OrgChartDbServer.log";
$error_log = "$org_chart_dir/error/OrgChartDbServer.err";

$javabindir = "$javadir/bin";

######################################
# Return the "No Response" status
# code to the browser.
######################################

print "Content-type: text/plain", "\n";
print "Status: 204 No Response", "\n\n";

######################################
# start the server
######################################

$ENV{'CLASSPATH'} = ".:$javaclasses";

unlink "$output_log";
unlink "$error_log";

chdir "$org_chart_dir/java";

if ( $pid = fork ) { # parent
	exit ( 1 );
}
elsif ( defined $pid ) { # child

	close( STDOUT ) || die "couldn't close STDOUT";
	open ( STDOUT, ">$output_log" ) || die "couldn't open $output_log";
	close( STDERR ) || die "couldn't close STDERR";
	open ( STDERR, ">>$error_log" ) || die "couldn't open $error_log";
	select(STDERR);
	$| = 1;

	print STDERR "Starting server at:   ", `date`;
	print STDERR "Current directory is: ", `pwd`;
	print STDERR "CLASSPATH is set to:  ", "$ENV{'CLASSPATH'}", "\n";

	exec "$javabindir/java", "OrgChartDbServer";
}
